<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import _, { cloneDeep } from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { api } from "~/common/constaint";
import { jsPDF } from "jspdf";
import html2canvas from "html2canvas";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class AdminOrderDetailComponent extends Vue {
  orderId = "";
  orderDetail: any = {};
  shippingAddress = {};
  dialogTimeLine = false;
  dialogDeleteTimeline = false;

  timeLine = {
    content: "",
    time: 0,
  };
  timeLineId = "";

  loading = false;
  menuDatePicker = false;
  datePicker = moment().format("YYYY-MM-DD");
  menuTimePicker = false;
  timePicker = moment().format("HH:mm");

  listLinkProduct: any = [];

  dialogEditShipping = false;

  loadingPrintf = false;
  loadingOrder = false;

  settings = {};
  loadingTable = false;
  mounted() {
    this.orderId = this.$route.params.id || "";
    const siteInfo = _.cloneDeep(this.$store.state.setting.siteInfo);
    if (siteInfo) {
      this.settings = siteInfo;
    }
    this.onGetDetailOrder();
  }

  async onPrinfFilePdf() {
    var orderPay = document.getElementById("order-pay");
    var orderInfo = document.getElementById("order-info");
    var orderCustomer = document.getElementById("order-customer");
    const doc = new jsPDF();
    this.loadingPrintf = true;
    //@ts-ignore
    await html2canvas(orderPay).then(function (canvas) {
      // Export the canvas to its data URI representation
      var base64image = canvas.toDataURL("image/png");
      doc.addImage(base64image, "JPEG", 5, 40, 370, 25);
    });
    //@ts-ignore
    await html2canvas(orderInfo).then(function (canvas) {
      // Export the canvas to its data URI representation
      var base64image = canvas.toDataURL("image/png");
      doc.addImage(base64image, "JPEG", 5, 80, 140, 100);
    });
    //@ts-ignore
    await html2canvas(orderCustomer).then(function (canvas) {
      // Export the canvas to its data URI representation
      var base64image = canvas.toDataURL("image/png");
      doc.addImage(base64image, "JPEG", 145, 79, 60, 100);
    });
    doc.save("order-detail.pdf");
    this.loadingPrintf = false;
  }

  async onGetDetailOrder() {
    try {
      this.loadingTable = true;
      const response = await this.$api.order.adminGetOrder(this.orderId);
      if (response?.data) {
        this.orderDetail = response.data;
        this.shippingAddress = cloneDeep(this.orderDetail.shippingAddress);
        if (this.orderDetail?.cart?.listSelectedProduct?.length) {
          this.orderDetail.cart.listSelectedProduct.forEach((product: any) => {
            if (product && product.productId && product.productId.slug) {
              const link = this.linkProduct(product.productId.slug);
              const body = {
                name: product.productId.name,
                link,
              };
              this.listLinkProduct.push(body);
            }
          });
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogCreateTimeline() {
    this.dialogTimeLine = true;
    this.datePicker = moment().format("YYYY-MM-DD");
    this.timePicker = moment().format("HH:mm");
  }

  async onCreateTimeLine() {
    try {
      if (!this.timeLine.content) {
        return this.$pushNotification.error(`Please fill in the content field`);
      }
      this.loading = true;
      this.timeLine.time = momentz(
        `${this.timePicker} ${this.datePicker}`
      ).unix();
      await this.$api.order.adminCreateTimeLine(this.orderId, this.timeLine);
      this.dialogTimeLine = false;
      this.timeLine = {
        content: "",
        time: 0,
      };
      this.$pushNotification.success("Create a successful timeline");
      this.onGetDetailOrder();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  openDialogDeleteTimeline(timeLineId: string) {
    this.dialogDeleteTimeline = true;
    this.timeLineId = timeLineId;
  }

  async onDeleteTimeLine() {
    try {
      this.loading = true;
      await this.$api.order.adminDeleteTimeLine(this.orderId, this.timeLineId);
      this.timeLineId = "";
      this.$pushNotification.success("Delete timeline successfully");
      this.dialogDeleteTimeline = false;
      this.onGetDetailOrder();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  openDialogEditShipping() {
    this.dialogEditShipping = true;
  }

  async onUpdateShippngAddress() {
    try {
      this.loading = true;
      await this.$api.order.updateCustomerInfo(
        this.orderId,
        this.shippingAddress
      );
      this.$pushNotification.success("Update shipping succesfully!");
      this.dialogEditShipping = false;
      this.onGetDetailOrder();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  formatDate(date: string) {
    return this.$utils.formatDate(date, this.settings);
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  get calcSubtotal() {
    let price = 0;
    if (
      this.orderDetail &&
      this.orderDetail.listSelectedProductId &&
      this.orderDetail.listSelectedProductId.length
    )
      for (let item of this.orderDetail.listSelectedProductId) {
        price += item.price * item.quantity;
      }
    return price;
  }

  get calcDiscountPercentPrice() {
    return Math.round(
      (this.orderDetail.coupon.discount / this.orderDetail.subTotal) * 100
    );
  }

  get calcTotalPrice() {
    return (
      this.calcSubtotal + this.orderDetail.shipping - this.orderDetail.discount
    );
  }

  get billingSameShippingAddress() {
    let isSame = true;
    if (this.orderDetail.billingAddress) {
      isSame = this.$utils.deepEqual(
        this.orderDetail.shippingAddress,
        this.orderDetail.billingAddress
      );
    }
    return isSame;
    // const orderDetail = cloneDeep(this.orderDetail);
    // if (
    //   orderDetail &&
    //   orderDetail.listSelectedProductId &&
    //   orderDetail.listSelectedProductId.length
    // ) {
    //   for (let item of Object.keys(orderDetail.shippingAddress)) {
    //     if (item === "_id") {
    //       continue;
    //     }

    //     // if (
    //     // 	orderDetail.shippingAddress[item] !==
    //     // 	orderDetail.billingAddress[item]
    //     // ) {
    //     // 	return false;
    //     // }
    //   }
    // }
    // return true;
  }

  linkProduct(slug: string) {
    //@ts-ignore
    let arrLink: any = [];
    if (window.location.origin.includes("dash")) {
      arrLink = window.location.origin.split("dash.");
    } else {
      arrLink = window.location.origin.split("admin.");
    }
    const link = arrLink.join("");
    return `${link}/products/${slug}`;
  }

  convertLink(product: any) {
    return `https://${
      product.domain
    }/pages/order-tracking?order_code=${this.orderDetail.orderCode.replace(
      "#",
      ""
    )}`;
  }
}
</script>

<style>
.border-paid {
  background-color: #fff;
  border: 1px solid #93d7af;
  color: #27ae60;
}

.border-packed {
  background-color: #fef5ed;
  color: #f2994a;
}

.alert-time-line {
  border-left: 2px solid #48c78e;
  border-radius: 4px;
  border-width: 0 0 0 4px;
  padding: 1.25em 1.5em;
  background: #f7fdfa;
}

.alert-time-line p,
.alert-time-line span,
a {
  color: #257953;
}

.color-green-timeline {
  color: #008060;
}
</style>
